#include "dialog.h"
#include "ui_dialog.h"
#include <QDebug>

Dialog::Dialog(QWidget *parent) :
  QDialog(parent),
  ui(new Ui::Dialog)
{
  ui->setupUi(this);
}

Dialog::~Dialog()
{
  delete ui;
}

QByteArray Dialog::bin_to_hex(QByteArray bin)
{
  QByteArray hex;
  int count = bin.length();
  for (int i = 0; i < count; i++)
  {
    QByteArray ch;
    ch.append(bin[i]);
    hex += ch.toHex().toUpper();
  }
  return hex;
}

QByteArray Dialog::hex_to_bin(QByteArray hex)
{
  QByteArray bin;
  int count = hex.length() / 2;
  for (int i = 0; i < count; i ++)
  {
    QByteArray ch;
    ch.append(hex[i * 2]);
    ch.append(hex[i * 2 + 1]);
    int     no = ch.toInt(NULL, 16);
    bin += no;
  }
  return bin;
}

void Dialog::on_btnRC4_clicked()
{
  QString key = ui->edKey->text();
  QString plain = ui->edPlain->text();

  QByteArray _key;    _key.append(key);
  QByteArray _plain;  _plain.append(plain);

  if (ui->chkKeyHex->checkState() == Qt::Checked)
    _key = hex_to_bin(_key);
  if (ui->chkPlainHex->checkState() == Qt::Checked)
    _plain = hex_to_bin(_plain);

  QByteArray _cipher = _plain;
  rc4_key_struct rc4key;
  prepare_key((unsigned char*)_key.data(), _key.length(), &rc4key);
  rc4((unsigned char*)_cipher.data(), _cipher.length(), &rc4key);

  if (ui->chkCipherHex->checkState() == Qt::Checked)
    _cipher = bin_to_hex(_cipher);
  QString cipher = _cipher;
  ui->edCipher->setText(cipher);
}
